function [w]=ssperceptn(train_data,train_y,params);
% this function trains a single_step perceptron
%
% params: input parameter vector
%       Row 1: thresh, error value, err rate , default=.1;
%       Row 2: max_it, maximum number of iterations, default = 100000;
%       Row 3: rho, learning coefficient, default =.1
% train perceptron using the single-sample method
[n_train,nvar]=size(train_data);
thresh = params(1);max_it = params(2); rho = params(3);

% Initialize
rand('state',sum(100*clock));
w=rand(nvar,1);% intitialize weights to random values
err=10000;
err_cnt = zeros(max_it,1);n_it = 1;
rho_t = rho;
norm_data = sqrt(sum(train_data .* train_data,2));

while (err>thresh)&(n_it<max_it+1)
    % Select a training sample using a uniform distribution 
    ind = ceil(n_train*rand(1));
    ind = max(1,ind);ind = min(n_train,ind);% make sure index is in bounds
    %w,data_train(ind,1:nvar)',
    g = w' * train_data(ind,1:nvar)';
    if (g<0)&(train_y(ind)==1) % In class 1 misclassified to 2
        w = w + rho_t * train_data(ind,1:nvar)'/norm_data(ind);
    elseif (g>0)&(train_y(ind)==-1) % In class 2 misclassified to 1
        w = w - rho_t * train_data(ind,1:nvar)'/norm_data(ind);;
    end;
    % check classification accuracy with this vector
    if (rem(n_it,100)==0)
        check = ((train_data(:,1:nvar)*w)>=0)-((train_data(:,1:nvar)*w)<0);
        err_cnt(n_it) = sum(abs(check - train_y(1:n_train)))/2;
        err=err_cnt(n_it);
    end;
    n_it = n_it + 1;
    rho_t = rho*(max_it-n_it)/max_it;
end;

